SystemOrganization addCategory: #'Versionner-Morphic-UI-Widgets'!

PluggableIconListMorph subclass: #MBPluggableIconListMorph
	instanceVariableNames: 'getIconAtSelector getClickIconAtSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Morphic-UI-Widgets'!

!MBPluggableIconListMorph methodsFor: 'accessing' stamp: 'dkh 2/26/2011 16:10'!
getClickIconAtSelector
	"Answer the value of getClickIconAtSelector"

	^ getClickIconAtSelector! !

!MBPluggableIconListMorph methodsFor: 'accessing' stamp: 'dkh 2/26/2011 16:10'!
getClickIconAtSelector: anObject

	getClickIconAtSelector := anObject! !

!MBPluggableIconListMorph methodsFor: 'accessing' stamp: 'dkh 2/26/2011 15:57'!
getIconAtSelector
	"Answer the value of getIconAtSelector"

	^ getIconAtSelector! !

!MBPluggableIconListMorph methodsFor: 'accessing' stamp: 'dkh 2/26/2011 15:58'!
getIconAtSelector: anObject

	getIconAtSelector := anObject! !

!MBPluggableIconListMorph methodsFor: 'event handling' stamp: 'dkh 2/26/2011 15:59'!
iconAt: row
	^ self getIconAtSelector
		ifNotNil: [ self model perform: self getIconAtSelector with: row ]! !

!MBPluggableIconListMorph methodsFor: 'event handling' stamp: 'dkh 2/26/2011 16:24'!
mouseUp: event 
	"The mouse came up within the list; take appropriate action"
	
	| row previousSelectionIndex icon |
	row := self rowAtLocation: event position.
	(self enabled and: [model okToChange])
		ifFalse: [^ self].
	(autoDeselect == false and: [row == 0]) ifTrue: [^ self].  "work-around the no-mans-land bug"
	"No change if model is locked or receiver disabled"
	previousSelectionIndex := self selectionIndex.
	((autoDeselect == nil or: [autoDeselect]) and: [row == self selectionIndex])
		ifTrue: [self changeModelSelection: 0]
		ifFalse: [self changeModelSelection: row].
	Cursor normal show.
	self getClickIconAtSelector == nil  ifTrue: [ ^self ].
	"Trigger icon action"
	(previousSelectionIndex = self selectionIndex
		and: [ (row := self rowAtLocation: event position) ~= 0
		and: [ (icon := self iconAt: row) notNil
		and: [ (event position x - self left < icon width) ] ] ])
			ifTrue: [ model perform: self getClickIconAtSelector with: row ]! !
