SystemOrganization addCategory: #'Versionner-Morphic-UI-Browser'!

!ThemeIcons class methodsFor: '*versionner-morphic-ui-browser' stamp: 'AlexandreBergel 5/18/2011 18:49'!
versionnerIcon
	"Private - Generated method"
	^icons 
			at: #metacelloIcon
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self versionnerIconContents readStream) ].! !

!ThemeIcons class methodsFor: '*versionner-morphic-ui-browser' stamp: 'AlexandreBergel 5/18/2011 18:48'!
versionnerIconContents
	"Private - Method generated with the content of the file /Users/alexandrebergel/Desktop/metacello.png"
	^ 'iVBORw0KGgoAAAANSUhEUgAAABQAAAAQCAIAAACZeshMAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAM/SURBVDhPY7iMDVwCgcvXr9188uDZ
0wfPgejRvcdXr1y7ePEiSAIGGND0AuWAKh7ee/zqycv1GxbVzcpPnRSWMTGyY3bV8aP7vrz/
CjECogtFM1jnpQ+vP81c2mXapqAxX0ZhjqTqYkWt6aqaU5S0J6j4NdrfvXnj3t37EPsRmiE6
v777ntTpo7dSUnOBhNYSadN2ZTN/CeMcCf1aGZ0SCe1CCYcag3ev3gJVomgGOubj688ZPUEm
W8QNlogbrpGyr1UPzLSw2ayjtUxWc7mMxlI5jQWKytl8Vy6cu3b1OtAyqM1A1uP7T2cv67Xc
Lmy+Vtx0rZjpNImCojiHXWp6qyVs6lWnT+io7EkzXKyotFA8osbtw5tPQMtAmkEeuHT54a0H
9vPE7HaK2G4Ss9opnFDnnbTAw2SLmGmXxKQJLV4LDeum5GdOCNHeJKFaz/fqyatLF8E2AzU/
f/Sqbnam22kBlz2izrtEbXYJtLZUeq9UN98lUNiQkLjE3XCzsPYU3q2r19VNypm7etKHtx/h
Nl9+eu+5yxJB7xMCHgeF3PYL2+/hnjd1hvcaReuDfB3dNVErrC12CprOF7bqlbKcJu3eo/vy
KdhmoLV3bt5buGp60A2ugFOCfieEfI8JeRzly86P9Vgl5XJMILjBctvOdc4LZIMaLJxnK1rt
FtVr4nv1+DUowIC2v33+KWWeVcRtrtAL/OHX+YPOCQSeEjYr5Qm8K+h1QtB+B2dVc86HB1+O
7jjkOlfO9qCgX4PxxzdfIM6+cuvKXb8drLF3uROe8DnUCyc+EAu9ymtfIRHb5Oi1XsjvCq/H
SR7zqWwO63k9zooYrWTYtHHNvTugdMJw4+qtBWsnJXxjSHrHELSfzb/QyCCMz/8oy+E9R79/
+HP62MmgaeouO1l8rnK6n+Iwn8EyYVbzh7efLl4ApVCGyxev3H92o2tpQe/yssyK8KSPDGG3
GbIrY759/nn+/Pnr1268ffbh1LETS5fNW7Nm2cNbD188fXXhwgVE2r508fLdmw+fPQCGwr2u
FYUdS/NP3dr78P5jSB4ChiowM9y4fuvGtZtAP8JzBSJ5gvMgUB3IlAd3Hl+5hMg6WPMsRBAA
nKlGHrD3iwwAAAAASUVORK5CYII='! !

MCTool subclass: #MBAbstractBrowser
	instanceVariableNames: 'needsUpdating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Morphic-UI-Browser'!

!MBAbstractBrowser methodsFor: 'morphic-open close' stamp: 'dkh 3/2/2011 19:17'!
close
	self unregister.
	super close! !

!MBAbstractBrowser methodsFor: 'morphic ui' stamp: 'AlexandreBergel 3/5/2011 22:11'!
directRefresh
	self subclassResponsibility! !

!MBAbstractBrowser methodsFor: 'morphic ui' stamp: 'dkh 3/2/2011 19:15'!
listMorph: listSymbol
	^ self
		listMorph: (listSymbol, 'List') asSymbol
		selection: (listSymbol, 'Selection') asSymbol
		menu: (listSymbol, 'ListMenu:') asSymbol
		icon: (listSymbol, 'IconFor:') asSymbol
		 iconAt: (listSymbol, 'IconAt:') asSymbol
		clickIconAt:  (listSymbol, 'ClickIconAt:') asSymbol! !

!MBAbstractBrowser methodsFor: 'morphic ui' stamp: 'dkh 3/2/2011 19:15'!
listMorph: listSymbol selection: selectionSymbol menu: menuSymbol icon: iconSymbol iconAt: iconAtSymbol clickIconAt: clickIconAtSymbol
	^ (MBPluggableIconListMorph
		on: self
		list: listSymbol
		selected: selectionSymbol
		changeSelected: (selectionSymbol, ':') asSymbol
		menu: menuSymbol)
		getIconSelector: iconSymbol;
		getIconAtSelector: iconAtSymbol;
		getClickIconAtSelector: clickIconAtSymbol;
		autoDeselect: false;
		yourself
! !

!MBAbstractBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 3/5/2011 22:57'!
needsUpdating
	"Answer a boolean saying if the browser has to be refreshed or not. This is used in the Morphic #step method"
	
	needsUpdating ifNil: [ needsUpdating := false ].
	^needsUpdating! !

!MBAbstractBrowser methodsFor: 'updating' stamp: 'dkh 3/2/2011 19:18'!
register
	"Set up dependencies"
	
! !

!MBAbstractBrowser methodsFor: 'morphic-open close' stamp: 'dkh 3/2/2011 19:17'!
show
	"Open the tool returning the window."

	self register.
	modal := false.
	^ (self window)
		openInWorldExtent: self defaultExtent;
		yourself! !

!MBAbstractBrowser methodsFor: 'morphic ui' stamp: 'dkh 3/2/2011 19:16'!
step
	"Override of the step Morphic method. This method is regularly called by Morphic"
	
	self needsUpdating ifFalse: [ ^self ].
	needsUpdating := false.
	self directRefresh ! !

!MBAbstractBrowser methodsFor: 'updating' stamp: 'dkh 3/2/2011 19:18'!
unregister
	"Unregister from the dependent object. Typically used when closing the browser"
	
! !

!MBAbstractBrowser methodsFor: 'morphic ui' stamp: 'dkh 3/2/2011 19:16'!
wantsSteps
	"Overridden by morphic classes whose instances want to be stepped,
	or by model classes who want their morphic views to be stepped."

	^ true! !

MBAbstractBrowser subclass: #VersionnerBrowser
	instanceVariableNames: 'configurationRoot configurationSelection infoSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Morphic-UI-Browser'!

!VersionnerBrowser class methodsFor: 'world menu integration' stamp: 'AlexandreBergel 5/18/2011 19:24'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #VersionnerBrowser)
"		order: 3; "
		parent: #Tools;
		label: 'Versionner';
		icon:  ThemeIcons versionnerIcon;
		action: [ VersionnerBrowser open ]! !

!VersionnerBrowser class methodsFor: 'open' stamp: 'AlexandreBergel 3/26/2011 23:00'!
open
	^ self new show; yourself ! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'dkh 3/6/2011 17:08'!
addConfiguration

	(MBAddConfigurationCommand target: nil for: self) execute.
	self changed: #configurationList! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 19:00'!
addDevelopment

	(MBSaveAllPackagesAndAddVersionCommand target: self selectedConfigurationInfo for: self) execute.
! !

!VersionnerBrowser methodsFor: 'morphic ui' stamp: 'AlexandreBergel 5/18/2011 19:10'!
buttonSpecs
 	^ #(
			('Load project' loadProject 'Load a configuration from SqueakSource')
			('+Configuration' addConfiguration 'Create a new configuration, complete with baseline and literal version open for development')
			('Update' updateDevelopment 'Update to the latest #development version')
			('Commit' addDevelopment 'Create a new development version.')
			('Help' showHelp 'Open the help window')
	)! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'dkh 3/22/2011 19:10'!
checkpointSave
	"right now does a straight save, but eventually should offer to merge if there are later versions in the repository"

	(MBCheckpointDevCommand target: self selectedConfigurationInfo for: self ) execute! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/27/2011 13:16'!
configuration
	"a ConfigurationInfo"
	
	^configurationSelection! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/27/2011 13:16'!
configuration: aConfigurationInfo
	configurationSelection := aConfigurationInfo! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 1/17/2012 17:30'!
configurationClass
	"Return the configuration class that is selected"
	
	^ configurationSelection configurationClass! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 1/17/2012 17:16'!
configurationClasses
	"Return the list of Configurations"
	^ (Smalltalk allClasses select: [ :cls | cls name beginsWith: #ConfigurationOf]) ! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 16:14'!
configurationClickIconAt: index

	^(self configurationList at: index) browseValidationResults! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 16:00'!
configurationIconAt: index

	^(self configurationList at: index) validationIcon ! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 11:36'!
configurationIconFor: aConfigurationInfo

	^aConfigurationInfo validationIcon! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 3/6/2011 14:44'!
configurationInfos
	^self configurationRoot configurations! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 11:29'!
configurationList
	^ self configurationInfos! !

!VersionnerBrowser methodsFor: 'morphic ui' stamp: 'dkh 3/6/2011 16:01'!
configurationListMenu: aMenu 
	self configurationInfos ifEmpty: [ ^ aMenu ].
	configurationSelection ifNil: [ ^ aMenu ].
	configurationSelection listMenu: aMenu requestor: self.

	^ aMenu! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 3/10/2011 18:11'!
configurationRoot
	
	configurationRoot ifNil: [ configurationRoot := MBConfigurationRoot current ].
	^configurationRoot! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 3/6/2011 15:39'!
configurationRoot: aContigurationRoot
	
	configurationRoot ifNotNil: [ configurationRoot removeDependent: self ].
	configurationRoot := aContigurationRoot
	

	
! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 1/16/2011 21:57'!
configurationSelection
	configurationSelection ifNil: [ ^ 0 ].

	self configurationInfos 
		doWithIndex: [ :configInfo :index | 
						(configInfo configurationClass == configurationSelection configurationClass)
							ifTrue: [ ^ index ] ].
	^ 0! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/27/2011 18:17'!
configurationSelection: aNumber
	aNumber = 0
		ifTrue: [self configuration: nil]
		ifFalse: [self configuration: (self configurationInfos at: aNumber)].
	self directRefresh.
	
	"self changedButtons.
"! !

!VersionnerBrowser methodsFor: 'morphic ui' stamp: 'dkh 2/28/2011 00:20'!
defaultExtent
	^ 600@500! !

!VersionnerBrowser methodsFor: 'updating' stamp: 'dkh 3/10/2011 17:55'!
directRefresh
	self updateInfosList.
	self updateConfigurationList.
! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 1/1/2011 13:49'!
info
	^ infoSelection ! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 1/1/2011 13:49'!
info: aString
	infoSelection := aString ! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 16:14'!
infoClickIconAt: index

	^(self infoList at: index) browseValidationResults! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 16:00'!
infoIconAt: index

	^(self infoList at: index) validationIcon ! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/26/2011 12:05'!
infoIconFor: anInfo

	^anInfo validationIcon! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 3/5/2011 22:58'!
infoList

	| info |
	configurationSelection ifNil: [ ^ #() ].
	(info:= self selectedConfigurationInfo) ifNil: [ ^#() ].
	^info infos! !

!VersionnerBrowser methodsFor: 'morphic ui' stamp: 'dkh 3/6/2011 16:01'!
infoListMenu: aMenu 
	self info ifNil: [ ^ aMenu ].
	
	self info listMenu: aMenu requestor: self..

	^ aMenu! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/27/2011 16:10'!
infoSelection
	"Return the index of the selected info"

	| info |
	infoSelection ifNil: [ ^ 0 ].
	configurationSelection ifNil: [ ^ 0 ].
	(info := self selectedConfigurationInfo) == nil
		ifTrue: [ ^ 0 ].
	info infos
		doWithIndex: [ :element :index | 
			element name = infoSelection name
				ifTrue: [ ^ index ] ].
	^ 0! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/27/2011 16:43'!
infoSelection: aNumber
	aNumber = 0
		ifTrue: [ self info: nil ]
		ifFalse: [ self info: (self infoList at: aNumber) ].

	self updateInfosList
! !

!VersionnerBrowser methodsFor: 'initialize-release' stamp: 'AlexandreBergel 3/1/2011 16:26'!
initialize 
	super initialize.
	self configurationSelection: 1.
! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'Anonymous 3/10/2011 23:22'!
loadConfiguration
	(MBLoadConfigurationCommand target: self for: self) execute.
	self directRefresh! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 19:09'!
loadProject
	(MBLoadProjectCommand target: self for: self) execute.
	self directRefresh! !

!VersionnerBrowser methodsFor: 'updating' stamp: 'dkh 2/27/2011 18:11'!
refresh

	needsUpdating := true.! !

!VersionnerBrowser methodsFor: 'updating' stamp: 'dkh 3/10/2011 17:53'!
register
	"Set up dependencies"
	
	MBConfigurationRoot current announcer
		on: MBConfigurationInfoCreated send: #refresh to: self;
		on: MBConfigurationInfoChanged send: #refresh to: self;
		on: MBConfigurationInfoDeleted send: #refresh to: self;
		on: MBInfoListChanged send: #refresh to: self.
! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'dkh 3/6/2011 17:01'!
releaseDevelopmentVersion
	(MBReleaseDevelopmentVersionCommand target: self selectedConfigurationInfo for: self) execute! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'dkh 2/27/2011 15:13'!
selectedConfigurationInfo
	| index |
	(index := self configurationSelection) == 0
		ifTrue: [ ^ nil ].	
	^ self configurationList at: index! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'dkh 4/6/2011 15:30'!
showHelp

	(MBHelpCommand target: self selectedConfigurationInfo for: self) execute! !

!VersionnerBrowser methodsFor: 'accessing' stamp: 'AlexandreBergel 5/18/2011 19:24'!
title
	^ 'Versionner'! !

!VersionnerBrowser methodsFor: 'updating' stamp: 'dkh 3/10/2011 17:51'!
unregister
	"Unregister from the dependent object. Typically used when closing the browser"
	
	MBConfigurationRoot current announcer unsubscribe: self  ! !

!VersionnerBrowser methodsFor: 'updating' stamp: 'dkh 3/6/2011 19:06'!
updateConfigurationList
	MBPlatform current showExecuteWhile: [ self changed: #configurationList]! !

!VersionnerBrowser methodsFor: 'actions' stamp: 'AlexandreBergel 6/10/2011 16:49'!
updateDevelopment
	
	"Simply update the configuration"
	(MBUpdateFromItsRepositoryCommand target: self selectedConfigurationInfo for: self ) execute
	 
	
	"right now does a straight load, but should do a merge for modified
	packages"
"	(MBUpdateDevCommand target: self selectedConfigurationInfo for: self ) execute"! !

!VersionnerBrowser methodsFor: 'updating' stamp: 'dkh 3/6/2011 19:06'!
updateInfosList
	MBPlatform current showExecuteWhile: [ self changed: #infoList.]! !

!VersionnerBrowser methodsFor: 'morphic ui' stamp: 'dkh 2/26/2011 11:02'!
widgetSpecs
	^ #(
		((buttonRow) (0 0 1 0) (0 0 0 30))
		((listMorph: configuration) (0 0 0.5 1) (0 30 0 0))
		((listMorph: #info) (0.5 0 1 1) (0 30 0 0))
		)! !
