
!MBConfigurationInfoCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:18'!
isActive
	^ (target isKindOf: MBConfigurationInfo) and: [ requestor isSelected: targetNode ]! !

!MBBranchConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/7/2011 22:21'!
group
	^ #buttons! !

!MBAddDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/7/2011 21:48'!
buttonLabel 

	^'+Dev'! !

!MBAddDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/7/2011 21:48'!
group
	^ #buttons! !

!MBAddDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/9/2011 20:27'!
isActive
	^ super isActive
		and: [ [ target version notNil ] on: Error do: [ :ex | ^ false ] ]! !

!MBAddDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/7/2011 21:48'!
wantsButton 

	^true! !

!MBSetCurrentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/3/2011 17:09'!
isActive
	^ (target isKindOf: MBVersionInfo) and: [ requestor isSelected: targetNode ]! !

!MBLoadPackageCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/20/2011 16:41'!
isActive
	^ (target isKindOf: MBSpecInfo) and: [ requestor isSelected: targetNode ]! !

!MBOpenForDevelopmentCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/11/2011 17:16'!
isActive
	^ (target isKindOf: MBVersionInfo) and: [ requestor isSelected: targetNode ]! !

!MBAbstractPackageInfoCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:17'!
isActive
	^ (target isKindOf: MBAbstractPackageInfo) and: [ requestor isSelected: targetNode ]! !

!MBReleaseDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:13'!
buttonLabel 

	^'Release Dev'! !

!MBReleaseDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:23'!
group
	^ #buttons! !

!MBReleaseDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/8/2011 16:07'!
isActive
	^ super isActive
		and: [ [ target configurationInfo project hasVersion: #development ] on: Error do: [ :ex | ^ false ] ]! !

!MBReleaseDevelopmentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:13'!
wantsButton 

	^true! !

!MBHelpCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:09'!
buttonLabel

	^'Help'! !

!MBHelpCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:22'!
group
	^ #buttons! !

!MBHelpCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:57'!
isActive
	^ super isActive or: [targetNode isNil and: [self wantsButton] ]! !

!MBHelpCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:09'!
wantsButton 

	^true! !

!MBUpdateProjectCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/10/2011 12:36'!
isActive
	^ super isActive and: [target configurationInfo currentVersion notNil ]! !

!MBPackageHistoryCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/20/2011 14:00'!
isActive
	^ (target isKindOf: MBPackageInfo) and: [ requestor isSelected: targetNode ]! !

!MBCommand class methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:52'!
on: target for: requestor

	^ self new setTarget: target requestor: requestor! !

!MBCommand class methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:19'!
takesNodes

	^true! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 10:09'!
addItemToMenu: aMenu
	self isActive ifTrue:
		[aMenu
			add: self labelWithKeystroke
			target: self 
			selector: #executeInTransaction
			enabled: self isEnabled
			icon: self icon]! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:10'!
buttonLabel
	^ self label! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:57'!
cluster
	^ nil! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:57'!
group
	^ #general! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:01'!
icon

	^nil! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:28'!
isActive

	^false! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:01'!
isEnabled

	^true! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 16:10'!
keystroke

	^nil! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'DaleHenrichs 03/05/2011 12:08'!
label

	^self title! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:01'!
labelWithKeystroke

	^self title! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:02'!
longDescription

	^self documentation ! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:15'!
setTarget: aNode requestor: aRequestor 
	targetNode := aNode.
	aNode ifNotNil: [target := aNode info].
	requestor := aRequestor! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:16'!
takesNodes

	^self class takesNodes! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:09'!
wantsButton
	"Put this here for compatibility. Eventually this will be obsolete"

	^ false
! !

!MBCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:23'!
wantsMenu
	"Put this here for compatibility. Eventually this will be obsolete"

	^ true
! !

!MBAddConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:12'!
buttonLabel

	^'+Configuration'! !

!MBAddConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:22'!
group
	^ #buttons! !

!MBAddConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:11'!
wantsButton 

	^true! !

!MBInfoCommand methodsFor: '*versionner-ob-ui' stamp: 'DaleHenrichs 03/07/2011 15:00'!
isActive
	^ (target isKindOf: MBInfo) and: [ requestor isSelected: targetNode ]! !

!MBCompareToStableVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 04/06/2011 19:56'!
isActive
	^ super isActive and: [[target configurationInfo project hasVersion: #stable ] on: Error do: [:ex | ^false ] ]! !

!MBLoadConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:10'!
buttonLabel
	^ 'Load configuration'! !

!MBLoadConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:23'!
group
	^ #buttons! !

!MBLoadConfigurationCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:11'!
wantsButton 

	^true! !

!MBConfigurationInfo methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/3/2011 20:12'!
asNode

	^(MBConfigurationInfoNode new)
		info: self;
		yourself ! !

!MBSetDescriptionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/20/2011 16:37'!
isActive
	^ (target isKindOf: MBVersionInfo) and: [ requestor isSelected: targetNode ]! !

!MBCheckpointDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:12'!
buttonLabel

	^'Checkpoint Dev'! !

!MBCheckpointDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:22'!
group
	^ #buttons! !

!MBCheckpointDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 04/06/2011 19:55'!
isActive
	^ super isActive and: [[target configurationInfo project hasVersion: #development ] on: Error do: [:ex | ^false ] ]! !

!MBCheckpointDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:12'!
wantsButton 

	^true! !

!MBVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 06:18'!
isActive
	^ (target isKindOf: MBAbstractVersionInfo) and: [ requestor isSelected: targetNode ]! !

!MBInfo class methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/4/2011 05:11'!
cmdNew
	"This is uglier, we shouldn't have to create an instance to get the cmd class ... temporary measure"
	^ super new! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/3/2011 20:14'!
asNode

	^(MBInfoNode new)
		info: self;
		yourself ! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:26'!
calculateValidationIcon

	| issues hasWarning |
	issues := self validate.
	issues == nil ifTrue:[ ^nil ].
	hasWarning := false.
	issues do: [:issue |
		(issue isError or: [ issue isCritical ]) ifTrue: [ ^self validateRed ].
		hasWarning := true ].
	hasWarning ifTrue: [ ^self validateOrange ].
	^self validateGreen! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:27'!
calculateValidationIconSymbol

	| issues hasWarning |
	issues := self validate.
	issues == nil ifTrue:[ ^#blank ].
	hasWarning := false.
	issues do: [:issue |
		(issue isError or: [ issue isCritical ]) ifTrue: [ ^#validateRed ].
		hasWarning := true ].
	hasWarning ifTrue: [ ^#validateOrange ].
	^#validateGreen! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 18:52'!
listMenu: aMenu requestor: requestor
	(((self commands select: [:each | each isMorphicCommand]) 
		collect: [ :commandClass |commandClass target: self for: requestor])
			asArray sort: [:a :b | a order <= b order ]) 
				do: [:command |
					aMenu add: command title target: command selector: #executeInTransaction ].
	^ aMenu
! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 18:49'!
validateGray
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 471604252 471604252 471604252 471604252 471604252 471604252 471604252 471604252 471604252 471604245 67180800 52173852 471604228 302583304 119282716 471604225 436213762 370940956 471604237 319162885 270277660 471604247 117572884 253500444 471604227 101388571 203168796 471604252 471604252 471604252 471604252 471604252 471604252 471604252 471604252 471604252)
	offset: 0@0)
	colorsFromArray: #(#(0.761 0.761 0.761) #(0.62 0.62 0.62) #(0.788 0.788 0.788) #(0.949 0.949 0.949) #(0.776 0.776 0.776) #(0.764 0.764 0.764) #(0.733 0.733 0.733) #(0.741 0.741 0.741) #(0.745 0.745 0.745) #(0.871 0.871 0.871) #(0.714 0.714 0.714) #(0.542 0.542 0.542) #(0.934 0.934 0.934) #(0.608 0.608 0.608) #(0.855 0.855 0.855) #(0.694 0.694 0.694) #(0.53 0.53 0.53) #(0.522 0.522 0.522) #(0.772 0.772 0.772) #(0.836 0.836 0.836) #(0.717 0.717 0.717) #(0.953 0.953 0.953) #(0.553 0.553 0.553) #(0.753 0.753 0.753) #(0.729 0.729 0.729) #(0.612 0.612 0.612) #(0.867 0.867 0.867) #(0.69 0.69 0.69) #( ) ))! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:26'!
validateGreen
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505302 1248283 337847075 589505280 185011458 488842019 589505281 270075936 404955939 589505298 237047580 170074915 589505303 520428049 505619235 589505284 571803907 102966051 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315)
	offset: 0@0)
	colorsFromArray: #(#(0.624 0.863 0.612) #(0.372 0.761 0.353) #(0.585 0.8 0.573) #(0.588 0.721 0.569) #(0.922 0.961 0.918) #(0.639 0.831 0.631) #(0.914 0.937 0.91) #(0.761 0.887 0.757) #(0.538 0.8 0.534) #(0.329 0.6 0.298) #(0.333 0.616 0.306) #(0.608 0.84 0.592) #(0.372 0.753 0.349) #(0.733 0.875 0.729) #(0.71 0.863 0.706) #(0.522 0.792 0.514) #(0.753 0.883 0.753) #(0.565 0.761 0.549) #(0.369 0.741 0.345) #(0.372 0.764 0.353) #(0.922 0.965 0.918) #(0.337 0.631 0.31) #(0.926 0.973 0.922) #(0.616 0.827 0.6) #(0.345 0.651 0.314) #(0.585 0.823 0.585) #(0.608 0.815 0.6) #(0.62 0.84 0.604) #(0.616 0.815 0.604) #(0.608 0.807 0.596) #(0.592 0.729 0.573) #(0.585 0.796 0.569) #(0.643 0.831 0.635) #(0.545 0.8 0.542) #(0.608 0.796 0.592) #( ) ))! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:26'!
validateOrange
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505292 1318158 52634403 589505280 353567759 186852131 589505308 35522317 572728099 589505298 136384537 539173667 589505311 151064856 102966051 589505302 454694661 170074915 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315)
	offset: 0@0)
	colorsFromArray: #(#(1.0 0.784 0.553) #(1.0 0.8 0.577) #(1.0 0.883 0.737) #(1.0 0.949 0.898) #(1.0 0.871 0.714) #(0.883 0.667 0.498) #(0.891 0.667 0.498) #(1.0 0.753 0.458) #(1.0 0.848 0.674) #(1.0 0.741 0.482) #(0.969 0.926 0.898) #(0.984 0.741 0.498) #(1.0 0.957 0.91) #(1.0 0.8 0.581) #(1.0 0.764 0.522) #(1.0 0.753 0.494) #(1.0 0.737 0.431) #(1.0 0.776 0.53) #(1.0 0.612 0.216) #(1.0 0.883 0.741) #(1.0 0.631 0.243) #(1.0 0.776 0.549) #(0.996 0.949 0.898) #(0.879 0.494 0.164) #(1.0 0.71 0.435) #(1.0 0.772 0.534) #(0.918 0.526 0.164) #(0.969 0.725 0.498) #(1.0 0.635 0.239) #(1.0 0.628 0.228) #(1.0 0.796 0.526) #(1.0 0.757 0.51) #(0.894 0.506 0.164) #(1.0 0.757 0.466) #(0.937 0.538 0.164) #( ) ))! !

!MBInfo methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:26'!
validateRed
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505302 269830 287515427 589505280 151065628 488842019 589505282 437981986 220406563 589505288 236066819 186852131 589505290 555032591 86188835 589505311 202835737 270738211 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315 589505315)
	offset: 0@0)
	colorsFromArray: #(#(1.0 0.51 0.498) #(0.984 0.737 0.725) #(0.98 0.177 0.164) #(0.953 0.534 0.526) #(0.988 0.177 0.164) #(0.815 0.498 0.522) #(0.965 0.502 0.498) #(0.761 0.164 0.185) #(0.949 0.173 0.164) #(0.992 0.506 0.502) #(0.949 0.502 0.498) #(0.78 0.164 0.185) #(0.902 0.498 0.502) #(0.827 0.164 0.177) #(0.973 0.674 0.663) #(0.894 0.47 0.474) #(0.953 0.898 0.906) #(0.988 0.898 0.898) #(0.961 0.466 0.439) #(0.961 0.455 0.431) #(0.98 0.71 0.694) #(0.961 0.577 0.565) #(1.0 0.902 0.898) #(0.804 0.164 0.181) #(0.957 0.423 0.404) #(0.804 0.498 0.522) #(0.984 0.737 0.721) #(0.973 0.526 0.494) #(0.941 0.49 0.49) #(0.922 0.498 0.502) #(0.969 0.177 0.164) #(0.984 0.898 0.898) #(0.953 0.534 0.522) #(0.934 0.486 0.486) #(0.961 0.581 0.569) #( )))! !

!MBLoadProjectCommand methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:04'!
buttonLabel
	^ 'Load project'! !

!MBLoadProjectCommand methodsFor: '*versionner-ob-ui' stamp: 'AlexandreBergel 5/18/2011 19:04'!
group
	^ #buttons! !

!MBSaveAllPackagesAndAddVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 04/06/2011 19:56'!
isActive
	^ super isActive and: [[target configurationInfo project hasVersion: #development ] on: Error do: [:ex | ^false ] ]! !

!MBDevCycleCommands methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:56'!
isActive
	^ (target isKindOf: MBInfo) and: [ requestor isSelected: targetNode ]! !

!MBRevertPackageCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/8/2011 16:09'!
isActive
	^ ((target isKindOf: MBPackageInfo) or: [ target isKindOf: MBConfigurationInfo ]) and: [ requestor isSelected: targetNode ]! !

!MBCompareToCurrentVersionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 16:18'!
isActive
	^ super isActive and: [target configurationInfo currentVersion notNil ]! !

!MBSavePackageCommand methodsFor: '*versionner-ob-ui' stamp: 'DaleHenrichs 03/07/2011 15:35'!
isActive
	^ (target isKindOf: MBPackageInfo) and: [ requestor isSelected: targetNode ]! !

!MBLoadProjectFromArchiveCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/7/2011 20:37'!
group
	^ #buttons! !

!MBPackageChangesCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/20/2011 16:42'!
isActive
	^ (target isKindOf: MBPackageInfo) and: [ requestor isSelected: targetNode ]! !

!MBUpdateDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:12'!
buttonLabel

	^'Update Dev'! !

!MBUpdateDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 15:23'!
group
	^ #buttons! !

!MBUpdateDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 04/06/2011 19:54'!
isActive
	^ super isActive and: [[target configurationInfo project hasVersion: #development ] on: Error do: [:ex | ^false ] ]! !

!MBUpdateDevCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 12:12'!
wantsButton 

	^true! !

!MBAddDescriptionCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/20/2011 16:19'!
isActive
	^ (target isKindOf: MBVersionInfo) and: [ requestor isSelected: targetNode ]! !

!MBUpdatePackageCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 4/6/2011 16:18'!
isActive
	^ super isActive and: [target configurationInfo currentVersion notNil ]! !

!MBCopyBaselineCommand methodsFor: '*versionner-ob-ui' stamp: 'dkh 3/20/2011 16:36'!
isActive
	^ (target isKindOf: MBBaselineInfo) and: [ requestor isSelected: targetNode ]! !
